c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                  program ampcheck
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         character*64 infil
         include 'common.grid'
         include 'common.field'

         write(6,210)
  210 format('What is the input file name')
         read(5,110) infil  
         open(unit=1, status='old', file=infil, form='formatted')

         read(1,100) ix, jx, kx
         read(1,101) dx,dy,dz,dt,amp,dd,ppr,omega,theta,phi,xlength

         do i=0, ix+1
           read(1,102) x(i)
         enddo
         do j=0, jx+1
           read(1,102) y(j)
         enddo
         do k=0, kx+1
           read(1,102) z(k)
         enddo

          bymin=10000.
          bymax=-10000.
          bzmin=10000.
          bzmax=-10000.
          
          kxg=1
c          The actual kxg in the grid should be kxg=kx on the surface

         do n=1, 1000
           read(1,103, end=999) ns, time

          do j=0, jx+1
          do i=0, ix+1
           read(1,104) by(i,j,kxg), bz(i,j,kxg), ex(i,j,kxg)

           if(by(i,j,kxg).gt.bymax) then
               bymax=by(i,j,kxg)
               nymax=n
               timymax=time
               nsymax=ns
           endif

           if(by(i,j,kxg).lt.bymin) then
               bymin=by(i,j,kxg)
               nymin=n
               timymin=time
               nsymin=ns
           endif

           if(bz(i,j,kxg).gt.bzmax) then
                bzmax=bz(i,j,kxg)
                nzmax=n
                timzmax=time
                nszmax=ns
           endif

           if(bz(i,j,kxg).lt.bzmin) then
                bzmin=bz(i,j,kxg)
                nzmin=n
                timzmin=time
                nszmin=ns
           endif
 
          enddo
          enddo

          
         enddo
 
  100 format(3i6)
  101 format(11E14.6)
  102 format(E14.6)
  103 format(i10, E14.6)
  104 format(3E14.6)
  110 format(a64)

  999 continue
       nlast=n-1
       print*,' Output is on unit 11'

       write(11,205)
       write(11,110)  infil
       write(11,205)
       write(11,200) nlast
       write(11,206)
       write(11,201) nymin,timymin, nymax, timymax
       write(11,207) nsymin, nsymax
       write(11,202) bymin, bymax
       write(11,206)
       write(11,203) nzmin,timzmin, nzmax, timzmax
       write(11,207) nszmin, nszmax
       write(11,204) bzmin, bzmax
  207 format('     (NS :  ', 2(5x,i6), ')') 
  206 format('.................................')
  205 format('+++++++++++++++++++++++++++++++++++++++++++++++++++++++')
  204 format('bzmin = ', E14.6, '     bzmax = ', E14.6/)
  203 format('nzmin = ', i5,'   timzmin = ', E14.6,'     nzmax = ',
     1             i5, '   timzmax = ', E14.6/)
  202 format('bymin = ', E14.6, '     bymax = ', E14.6/) 
  201 format('nymin = ', i5,'   timymin = ', E14.6,'     nymax = ',
     1             i5, '   timymax = ', E14.6/)
  200 format(' nlast =', i5/)
      end
