ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c   calculate matrix multiplication y=a*x, where x, y is vectors and
c   see iccg.f for detail of a
c   mx, my, mz is the number of grids, not the size of a, xin, yout
C**********************************************************************
C   update log
C   Dec.  2, 1998  MPI version
C   Oct. 15, 1998  periodic BC
C   Sep.  1, 1998  coded by W. Chou
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      subroutine amultx(amain,xin,yout,mx,my,mz)
      include 'common.grid'
      include 'common.para'
      dimension amain(0:nx,0:ny,0:nz,6)
      dimension xin(0:nx,0:ny,0:nz),yout(0:nx,0:ny,0:nz)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     send/receive boundary terms before each calculation
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      call mpi_sendrecv(xin(1,1,kend),1,ionelayer,iup,1,
     &               xin(1,1,ksta-1),1,ionelayer,idown,1,
     &               mpi_comm_world,istatus,ierr)
      call mpi_sendrecv(xin(1,1,ksta),1,ionelayer,idown,1,
     &               xin(1,1,kend+1),1,ionelayer,iup,1,
     &               mpi_comm_world,istatus,ierr)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=1,mz
      do k=ksta,kend
      do j=1,my
      do i=1,mx
        yout(i,j,k)=amain(i,j,k,1)*xin(i,j,k)
     &       +amain(i,j,k,2)*xin(i,j,k-1)+amain(i,j,k+1,2)*xin(i,j,k+1)
     &       +amain(i,j,k,3)*xin(i,j-1,k)+amain(i,j+1,k,3)*xin(i,j+1,k)
     &       +amain(i,j,k,4)*xin(i-1,j,k)+amain(i+1,j,k,4)*xin(i+1,j,k)
      enddo
      enddo
      enddo
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     boundary terms
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     do k=1,mz
      do k=ksta,kend
       do i=1,mx
         yout(i,1,k)=yout(i,1,k)+amain(i,my,k,5)*xin(i,my,k)
         yout(i,my,k)=yout(i,my,k)+amain(i,1,k,5)*xin(i,1,k)
       enddo
       do j=1,my
         yout(1,j,k)=yout(1,j,k)+amain(mx,j,k,6)*xin(mx,j,k)
         yout(mx,j,k)=yout(mx,j,k)+amain(1,j,k,6)*xin(1,j,k)
       enddo
      enddo
      return
      end
