ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c 
c    Prepare the right hand side of the matrix equation S*A^(n+1)=PRE
c    for each time step, where PRE=T*A^n+(boundary terms).
c    After this subroutine is called, the boundary terms also advanced
c    to time ---> time+dt
c
***********************************************************************
C   update log
C   Oct. 17, 1998  for periodic boundary in X and Y
C   Sep.  1, 1998  coded by W. Chou
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      subroutine preprhs
      include 'common.grid'
      include 'common.field'
      include 'common.mat'
      include 'common.para'
      integer*4 mtime2,mtime1
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c    calculate T.A^n
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      call amultx(tmain,ax,prex,ix,jx,kx)
c     call amultx(tmain,ay,prey,ix,jx,kx)
c     call amultx(tmain,az,prez,ix,jx,kx)
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
c     calculate boundary in (n+1) time step
c     the right hand side of the matrix equation should also
c     include the boundary terms of t=n+1
ccccc&cc10cccccccc20cccccccc30cccccccc40cccccccc50cccccccc60cccccccc70c
      tp= time+dt
      if (myrank==0) then
       call bnd(tp)
       do j=1,jx
       do i=1,ix
         prex(i,j,1)=prex(i,j,1)+tmain(i,j,1,2)*ax(i,j,0)
         prey(i,j,1)=prey(i,j,1)+tmain(i,j,1,2)*ay(i,j,0)
         prez(i,j,1)=prez(i,j,1)+tmain(i,j,1,2)*az(i,j,0)
       enddo
       enddo
      endif
      if (myrank==lastrank) then
       call bnd(tp)
       do j=1,jx
       do i=1,ix
         prex(i,j,kx)=prex(i,j,kx)+tmain(i,j,kx,2)*ax(i,j,kxx)
         prey(i,j,kx)=prey(i,j,kx)+tmain(i,j,kx,2)*ay(i,j,kxx)
         prez(i,j,kx)=prez(i,j,kx)+tmain(i,j,kx,2)*az(i,j,kxx)
       enddo
       enddo
      endif
      return
      end
